
/** A generic class Pair<T>
    @author Patrick Prosser
    @ version 1.0 */

public class Pair<T> {

    private T first;
    private T second;

    public Pair(T first,T second){
	this.first = first;
	this.second = second;
    }

    public String toString(){return "<"+ first +","+ second +">";}
    public T first(){return first;}
    public T second(){return second;}

    public boolean equals(Object obj){
	return obj != null && getClass() == obj.getClass() && 
	        first.equals(((Pair<T>)obj).first()) && 
                second.equals(((Pair<T>)obj).second());
    }

    public static void main(String[] args) {

	Pair<Integer> p1 = new Pair<Integer>(3,5);
	Pair<Integer> p2 = new Pair<Integer>(5,3);
	Pair<String>  p3 = new Pair<String>("ted","alice");
	Pair<String>  p4 = new Pair<String>("nelson","poppy");
	Pair<Integer> p5 = new Pair<Integer>(5,3);

	System.out.println(p1 +" "+ p2 +" "+ p3 +" "+ p4);
	System.out.println(p1.equals(p2) +" "+ p2.equals(p5) +" "+ p1.equals(p3));
	
    }
}
	       
